# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section   free
%define oname   wsif

Name:           ws-wsif
Version:        2.1.0
Release:        0.rc1.2%{?dist}
Epoch:          0
Summary:        Web Service Invocation Framework

Group:          Development/Libraries/Java
License:        Apache Software License 2.0
URL:            http://ws.apache.org/wsif/
Source0:        http://people.apache.org/dist/ws/wsif/wsif-all-2.1.0_RC1.tgz
Source1:        ws-wsif-LICENSE
Patch0:		ws-wsif-AuthenticatingProxyWSDLLocatorImpl.patch
Patch1:		ws-wsif-WSIFWSDLLocatorImpl.patch
Patch2:		ws-wsif-WSIFUtils.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-nodeps
BuildRequires:  bsf
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  axis >= 0:1.2
BuildRequires:  apache-commons-discovery
BuildRequires:  apache-commons-logging
BuildRequires:  log4j
BuildRequires:  servlet_2_4_api
BuildRequires:  ws-soap = 0:2.3.1
BuildRequires:  wsdl4j >= 0:1.6.2
BuildRequires:  ejb_2_1_api
BuildRequires:  jms_1_1_api
BuildRequires:  javamail_1_3_1_api
Requires:  java >= 0:1.6.0
Requires:  axis >= 0:1.2
Requires:  apache-commons-discovery
Requires:  apache-commons-logging
Requires:  log4j
Requires:  servlet_2_4_api
Requires:  ws-soap = 0:2.3.1
Requires:  wsdl4j >= 0:1.6.2
Requires:  ejb_2_1_api
Requires:  jms_1_1_api
%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
The Web Services Invocation Framework (WSIF) is a simple Java 
API for invoking Web services, no matter how or where the 
services are provided. 
WSIF enables developers to interact with abstract 
representations of Web services through their WSDL descriptions 
instead of working directly with the Simple Object Access 
Protocol (SOAP) APIs, which is the usual programming model. 
With WSIF, developers can work with the same programming model 
regardless of how the Web service is implemented and accessed.
WSIF allows stubless or completely dynamic invocation of a Web 
service, based upon examination of the meta-data about the 
service at runtime. It also allows updated implementations of 
a binding to be plugged into WSIF at runtime, and it allows 
the calling service to defer choosing a binding until runtime.
Finally, WSIF is closely based upon WSDL, so it can invoke any 
service that can be described in WSDL.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.


%prep
%setup -q -n %{oname}-%{version}_RC1
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
cp %{SOURCE1} LICENSE
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
pushd lib
ln -sf $(build-classpath bsf)
# lib/ant-1_5_1.jar.no
ln -sf $(build-classpath ant)
# lib/apache_soap-2_3_1.jar.no
ln -sf $(build-classpath ws-soap)
# lib/axis-1_0-ant.jar.no
ln -sf $(build-classpath axis/axis-ant)
# lib/axis-1_0.jar.no
ln -sf $(build-classpath axis/axis)
# lib/commons-discovery.jar.no
ln -sf $(build-classpath commons-discovery)
# lib/commons-logging.jar.no
ln -sf $(build-classpath commons-logging)
# lib/jaxrpc-1_1.jar.no
ln -sf $(build-classpath axis/jaxrpc)
# lib/junit-3_8_1.jar.no
ln -sf $(build-classpath junit)
# lib/log4j-1_2_4.jar.no
ln -sf $(build-classpath log4j)
# lib/optional-1_5_1.jar.no
ln -sf $(build-classpath ant/ant-nodeps)
# lib/qname-from-wsdl4j-20021124.jar.no
ln -sf $(build-classpath wsdl4j/qname)
# lib/saaj-1_1.jar.no
ln -sf $(build-classpath axis/saaj)
# lib/servlet-2_2.jar.no
ln -sf $(build-classpath servlet_2_4_api)
# lib/soaprmi-1_1.jar.no
#
# lib/wsdl4j-20021124.jar.no
ln -sf $(build-classpath wsdl4j)
# lib/xercesImpl-2_2_1.jar.no
#ln -sf $(build-classpath xerces-j2)
# lib/xmlParserAPIs-2_2_1.jar.no
#ln -sf $(build-classpath xml-commons-apis)
popd
export CLASSPATH=$(./classpath.sh build)
CLASSPATH=$CLASSPATH:$(build-classpath ejb_2_1_api jms_1_1_api javamail_1_3_1_api):test:samples:build/lib/%{oname}.jar
ant -Ddebug=on all javadocs samples

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 build/lib/%{oname}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 644 LICENSE $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
# javadocs
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf doc/api
cp -pr doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%doc %{_datadir}/%{name}-%{version}
%{_javadir}/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Sat Jul 09 2011 Ralph Apel <r.apel at r-apel.de> - 0:2.1.0-0.rc1.2
- Carry on to JPP-6

* Tue Oct 17 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.1.0-0.rc1.1jpp
- First JPP release
- Add post/postun Requires for javadoc
- Add gcj_support option
- Note: unit tests must be fixed as such
